c------------------------------------------c
c Exercise: Circular Shift
c
c In this exercise you will communicate a matrix 
c among process in a circular topology, so that
c every process has a left and a right neighbor
c to receive and to send data respectivelly.
c
c Resolve deadlocks with the Sendrecv MPI function
c------------------------------------------c

      program main


      implicit none

      include 'mpif.h'
      integer i
      integer ierr,rank,size
      integer tag,from,to
      integer MSIZE
      parameter(MSIZE=500)
      integer A(MSIZE),B(MSIZE)

      integer status(MPI_STATUS_SIZE)
      
      
c--- Start up MPI  ----------- ----------------------------------------------
c ---> INSERT MPI code

c----- print banner --------------------------------------------------------c
      if (rank.eq.0) then
         print *
     $        ,'Circular shift example: each process fills matrix A' 
         print *
     $        ,'elements with its rank and sends them to the right'
         
         print *,'process which receives them into matrix B'
         print *

      endif
    
c---------------------------------------------------------------------------c
c    Arbitrarily choose 201 to be our tag. Calculate the rank of the        c
c    to process. Use the modulus operator so that the                     c
c    last process "wraps around" to rank zero.                              c
c---------------------------------------------------------------------------c

      tag=201
      to = mod(rank + 1,size)
      from = mod(rank + size - 1,size)

      do i=1,MSIZE
         A(i)=rank
      enddo 

      
c---  SendRECV of Array A ----------------------------------------------

c ---> INSERT MPI code


      print '(a4,2x,i2,2x,a8,2x,i5,2x,a18,2x,i4)','Proc',rank,'sends   '
     $     ,MSIZE,'integers to proc',to


      print '(a4,2x,i2,2x,a8,2x,i5,2x,a18,2x,i4)','Proc',rank,'receives'
     $     ,MSIZE,'integers from proc',from



c--- print first content of array A and B -----------------------------------

      print '(a4,2x,i2,2x,a10,2x,i2,2x,a10,i5)','Proc',rank,'has A(1) ='
     $     ,A(1),' and B(1) =',B(1)
      print '(a40)','**********************************'


c--- QUIT -------------------------------------------------------------------
      
c ---> INSERT MPI code
      
      end
