program laplace

    implicit none
    include "mpif.h"
    real (kind=8), dimension(:), allocatable :: T, Tnew, T0
    real (kind=8) :: tol, variation=1.0
    integer :: msize, maxIter, i, iter=0
    ! timing
    real (kind=8) :: startTime, endTime
    ! MPI variables
    integer :: ierr, rank, nprocs, status(MPI_STATUS_SIZE)
    integer :: right, left, tag=201, mymsize
    real (kind=8) :: myvariation=1.0

    ! MPI init...
! ---> INSERT MPI code

    if ( rank == 0 ) then
        write(*,*) 'Enter mesh size, max iterations and tollerance:'
        read(*,*)  msize, maxIter, tol
        ! process 0 allocates the global array T0 for displaying results 
        allocate (T0(msize))
    endif

    ! start time
! ---> INSERT MPI code

    ! broadcast input parameters (msize,maxIter,tol) from process 0 to others
! ---> INSERT MPI code

    if ( mod(msize,nprocs) /= 0 ) then
        if ( rank == 0 ) then
            write(*,*) 'The number of processes must fit the mesh size.'
            write(*,*) 'Mesh size           =', msize
            write(*,*) 'Number of processes =', nprocs
        endif
        call MPI_Finalize(ierr)
        stop
    endif

    ! calculating problem size/process
! ---> INSERT code
    mymsize = 

    ! rank of my processes neighbours
! ---> INSERT code
    right = 
    left  = 
    if ( rank == 0 )          left  = 
    if ( rank == (nprocs-1) ) right = 

    ! allocating memory for T and Tnew
    allocate (T(0:mymsize+1), Tnew(mymsize))

    ! set up boundary values
    T(0:mymsize+1) = 0.0
    if ( rank == (nprocs-1) ) T(mymsize+1) = 100.0

    do while (variation > tol .and. iter <= maxIter)

        iter = iter + 1

        !--- exchange boundary data with neighbours (right->left)
! ---> INSERT MPI code

        !--- exchange boundary data with neighbours (left->right)
! ---> INSERT MPI code

        ! calculating new solution
        Tnew = 0.5 * ( T(0:mymsize-1) + T(2:mymsize+1) )
        ! calculating the error
        myvariation = maxval(dabs( Tnew - T(1:mymsize) ))

        ! find the maximum values of variation among all processes
! ---> INSERT MPI code

        if( mod(iter,100) == 0 .and. rank == 0 ) &
            write(*,"(a,i8,e12.4)") ' iter, variation:', iter, variation

        ! updating solution
        T(1:mymsize) = Tnew
    enddo

    ! gather data to process 0 (into array T0) for displaying
! ---> INSERT MPI code

    ! end time
! ---> INSERT MPI code

    ! output of the results
    if ( rank == 0 ) then
        write(*,'(A,F10.4)') ' Elapsed time (s)     =', endTime - startTime

        write(*,*) 'Mesh size            =', msize
        write(*,*) 'Stopped at iteration =', iter
        write(*,*) 'The maximum error    =', variation
        
        open(10, file="results")
        do i = 1, msize
            write(10, "(i8, e18.9)") i, T0(i)
        end do
        close(10)
    endif
    
    deallocate (T, Tnew)

! ---> INSERT MPI code

end program laplace
